import subprocess

from os.path import expanduser
import os,time

def get_url():
    BIOJAVA_SPARK = "0.2.1"
    return "http://search.maven.org/remotecontent?filepath=org/biojava/biojava-spark/" + BIOJAVA_SPARK + "/biojava-spark-" + BIOJAVA_SPARK + "-allinone.jar"

def main_jar():
    home = expanduser("~")
    return os.path.join(home,"mmtf-pyspark.jar")

def download_file(url, file_name):
    import urllib2
    u = urllib2.urlopen(url)
    f = open(file_name, 'wb')
    meta = u.info()
    file_size = int(meta.getheaders("Content-Length")[0])
    print("Downloading: "+str(file_name)+" Bytes: "+str(file_size))

    file_size_dl = 0
    block_sz = 8192
    while True:
        buffer = u.read(block_sz)
        if not buffer:
            break

        file_size_dl += len(buffer)
        f.write(buffer)
        status = r"%10d  [%3.2f%%]" % (file_size_dl, file_size_dl * 100. / file_size)
        status = status + chr(8) * (len(status) + 1)
        print(status)
    f.close()

def download_jar():
    if not os.path.isfile(main_jar()):
        url = get_url()
        download_file(url,  main_jar())

if __name__ == "__main__":
    import db
    from mmtf_pyspark.api import setup, get_subset
    task = subprocess.Popen(["java","-cp", main_jar(), "org.biojava.spark.utils.EntryPoint"])
    time.sleep(2)
    pdb_data,spark_utils,gateway = setup()
    db.ipshell()
    gateway.shutdown()
    task.kill()
